(include-book "testing" :dir :teachpacks)
(check-expect (+ 2 2) 4)
(check-expect (+ 5 7) (+ 10 2))
(check-expect (+ 27 6) (+ (+ 24 5) (+ 2 2))) ;WARNING! formula corrected

(include-book "doublecheck" :dir :teachpacks)
(defproperty +associative-test
  (x :value (random-integer)
   y :value (random-integer)
   z :value (random-integer))
  (= (+ x (+ y z))
     (+ (+ x y) z)))

(check-expect (append (list 1 2 3 ) (list 4 5)) (list 1 2 3 4 5))
(check-expect (append (list 9 8 7) (list 6)) (list 9 8 7 6))
(check-expect (append (list 11 7) (list 2 5 3)) (list 11 7 2 5 3))
(check-expect (append (list 2 0) (list 1 8)) (list 2 0 1 8))

(defproperty additive-law-of-concatenation-test
  (xs :value (random-list-of (random-integer))
   ys :value (random-list-of (random-integer)))
  (= (len (append xs ys))
     (+ (len xs) (len ys))))

(check-expect (mod 12 2) 0)
(check-expect (mod 27 2) 1)

(check-expect (mod 14 3) 2)
(check-expect (mod  7 3) 1)
(check-expect (mod 18 3) 0)

(defproperty mod-invariant
  (divisor-minus-1 :value (random-natural)
   dividend        :value (random-natural))
  (let* ((divisor (+ divisor-minus-1 1))) ; avoid zero divisor
    (= (mod dividend divisor)
       (mod (+ dividend divisor) divisor))))
     
(defproperty mod-upper-limit-test
  (divisor-minus-1 :value (random-natural)
   dividend        :value (random-natural))
  (let* ((divisor (+ divisor-minus-1 1))) ; avoid zero divisor
    (< (mod dividend divisor) divisor)))

(defproperty mod-range-test
  (divisor-minus-1 :value (random-natural)
   dividend        :value (random-natural))
  (let* ((divisor (+ divisor-minus-1 1))) ; avoid zero divisor
    (and (natp (mod dividend divisor))
         (< (mod dividend divisor) divisor))))

(defproperty quotient-less-than-dividend-test
  (divisor-minus-2   :value (random-natural)
   dividend-minus-1  :value (random-natural))
  (let* ((divisor  (+ divisor-minus-2 2))   ; divisor  > 1
         (dividend (+ dividend-minus-1 1))) ; dividend > 0
    (< (floor dividend divisor)
       dividend)))

(defproperty division-check-test
  (divisor-minus-1 :value (random-natural)
   dividend        :value (random-natural))
  (let* ((divisor (+ divisor-minus-1 1))) ; avoid zero divisor
    (= (+ (* divisor (floor dividend divisor))
          (mod dividend divisor))
       dividend)))
