(include-book "testing" :dir :teachpacks)
(include-book "doublecheck" :dir :teachpacks)

(check-expect (len (cons 8 (cons 3 (cons 7 nil)))) 3)
(check-expect (len nil) 0)

(defproperty len-cons-test
  (x  :value (random-natural)
   xs :value (random-list-of (random-natural)))
  (= (len (cons x xs))
     (+ 1 (len xs))))

(defproperty len-rest-test
  (xs :value (random-list-of (random-natural)))
  (implies (consp xs)
           (= (len xs)
              (+ 1 (len (rest xs))))))

(check-expect (append '(1 2 3 4) '(5 6 7)) '(1 2 3 4 5 6 7))
(check-expect (append '(1 2 3 4 5) nil) '(1 2 3 4 5))

(defproperty append-test
  (xs :value (random-list-of (random-natural))
   ys :value (random-list-of (random-natural)))
  (equal (append xs ys)
         (if (consp xs)
             (cons (first xs)
                   (append (rest xs) ys))
             ys)))

; Note: defun append is redundant, so stated as comment
;(defun append (xs ys)    ; intrinsic operator, so defun is redundant
;  (if (consp xs)                              ; select formula
;      (cons (first xs) (append (rest xs) ys)) ; {app1}, xs not empty
;      ys))                                    ; {app0}, xs is empty

; Note: defun nthcdr is redundant, so stated as comment
;(defun nthcdr (n xs)    ; intrinsic operator, so defun is redundant
;  (if (and (posp n) (consp xs))   ; select formula
;      (nthcdr (- n 1) (rest xs))  ; {sfx1}
;      xs))                        ; {sf0}

(defun prefix (n xs)
  (if (and (posp n) (consp xs))
      (cons (first xs) (prefix (- n 1) (rest xs)))  ; {pfx1}
      xs))                                          ; {pfx0}

(defun rep (n x)
  (if (posp n)
      (cons x (rep (- n 1) x))   ; {rep1}
      nil))                      ; {rep0}
