(include-book "testing" :dir :teachpacks)
(include-book "doublecheck" :dir :teachpacks)

(defun mux (xs ys)
  (if (not (consp xs))
      ys                                             ; {mux0x}
      (if (not (consp ys))
          xs                                         ; {mux0y}
          (cons (first xs)
                (cons (first ys)
                      (mux (rest xs) (rest ys))))))) ; {mux11}

(defthm mux-length-thm
  (= (len (mux xs ys))
     (+ (len xs) (len ys))))

(defun occurs-in (x xs)
  (if (consp xs)
      (or (equal x (first xs))
          (occurs-in x (rest xs)))
      nil))
(defthm mux-val-thm
  (iff (occurs-in v (mux xs ys))
       (or (occurs-in v xs)
           (occurs-in v ys))))

(defun mux2 (xs ys) ; declare induction scheme
   (declare (xargs :measure (+ (len xs) (len ys))))
   (if (consp xs)
       (cons (first xs) (mux2 ys (rest xs))) ; {mux2-1x}
       ys))                                  ; {mux2-0x}

(defun dmx (xys)
  (if (consp (rest xys)) ; 2 or more elements?
      (let* ((x (first xys))
             (y (second xys))
             (xsys (dmx (rest (rest xys))))
             (xs (first xsys))
             (ys (second xsys)))
        (list (cons x xs) (cons y ys)))      ; {dmx2}
      (list xys nil)))  ; 1 element or none  ; {dmx1}

(defthm mux-inverts-dmx-thm
  (implies (true-listp xys)
           (equal (mux (first  (dmx xys))
                       (second (dmx xys)))
                  xys)))
(defthm dmx-inverts-mux-thm
  (implies (and (true-listp xs) (true-listp ys)
                (= (len xs) (len ys)))
           (equal (dmx (mux xs ys))
                  (list xs ys))))

(include-book "arithmetic-3/top" :dir :system)
(defthm dmx-len-first
   (= (len (first (dmx xs)))
      (ceiling (len xs) 2)))
(defthm dmx-len-second
   (= (len (second (dmx xs)))
      (floor (len xs) 2)))

(defthm dmx-length-thm
  (= (len xys)
     (+ (len (first (dmx xys)))
        (len (second (dmx xys))))))

