; DEFINITIONS FROM PREVIOUS CHAPTERS NEEDED HERE
(defun occurs-in (x xs)
  (if (consp xs)
      (or (equal x (first xs))
          (occurs-in x (rest xs)))
      nil))
(defun up (xs)     ; (up[x1 x2 x3 ...]): x1 <= x2 <= x3 ...
  (or (not (consp (rest xs)))          ; (len xs) <= 1
      (and (<= (first xs) (second xs)) ; x1 <= x2
           (up (rest xs)))))           ; x2 <= x3 <= x4 ...
;(defun dmx (xys)  ; WARNING! causes msort-len-inductive-case failure
;  (if (consp (rest xys)) ; 2 or more elements?
;      (let* ((x (first xys))
;             (y (second xys))
;             (xsys (dmx (rest (rest xys))))
;             (xs (first xsys))
;             (ys (second xsys)))
;        (list (cons x xs) (cons y ys)))      ; {dmx2}
;      (list xys nil)))  ; 1 element or none  ; {dmx1}
(defun dmx (xys)                ; xys = (x1 y1 x2 y2 x3 y3 ...)
  (if (consp xys)   ; WARNING! the book calls this version dmx2
      (let* ((x1 (first xys))
             (yxs (rest xys))   ; yxs  = (y1 x2 y2 x3 y3 x4 ...)
             (ysxs (dmx yxs))   ; ysxs = ((y1 y2 ...)(x2 x3 ...))
             (ys  (first ysxs)) ; ys   = (y1 y2 ...)
             (xs (second ysxs))); xs   = (x2 x3 ...)
        (list (cons x1 xs) ys)) ; {dmx1} ((x1 x2 ...)(y1 y2 ...))
      (list xys nil)))          ; {dmx0}
; END FROM PREVIOUS CHAPTERS NEEDED HERE
(defun mrg (xs ys)
   (declare (xargs :measure (+ (len xs) (len ys))))
   (if (and (consp xs) (consp ys))
       (let* ((x (first xs)) (y (first ys)))
             (if (<= x y)
                 (cons x (mrg (rest xs) ys))     ; {mg<}
                 (cons y (mrg xs (rest ys)))))   ; {mg>}
       (if (consp xs)
           xs         ; note: ys is empty    ; {mg1}
           ys)))      ; note: xs is empty    ; {mg0}
(defthm dmx-shortens-list ; lemma to help ACL2 admit def'n of msort
   (implies (consp (rest xs))
            (let* ((odds-evens (dmx xs)) ; xs = (x1 x2 ...)
                   (odds       (first odds-evens))
                   (evns       (second odds-evens)))
                  (and (< (len odds) (len xs))
                       (< (len evns) (len xs))))))
(defun msort (xs)
   (declare (xargs
             :measure (len xs)
                   :hints (("Goal"
                   :use ((:instance dmx-shortens-list))))))
   (if (consp (rest xs)) ; (len xs) > 1?
       (let* ((odds-evens (dmx xs)) ; xs = (x1 x2 ...)
              (odds       (first odds-evens))
              (evns       (second odds-evens)))
             (mrg (msort odds) (msort evns))) ;    {m-s2}
       xs))               ; xs = (x1) or empty {m-s1}
(defthm mrg-preserves-order
   (implies (and (up xs) (up ys))
            (up (mrg xs ys))))
(defthm msort-sorts-base-case
   (implies (not(consp(rest xs)))
            (up (msort xs))))
(defthm msort-sorts
   (up (msort xs)))
(defthm dmx-preserves-len
   (let* ((xsys (dmx xys))
          (odds (first xsys))
          (evns (second xsys)))
         (= (+ (len odds) (len evns))
            (len xys))))
(defthm mrg-preserves-len
   (= (len (mrg xs ys)) (+ (len xs) (len ys))))
(defthm msort-preserves-len-base-case
   (implies (not(consp(rest xs)))
            (= (len (msort xs))
               (len xs))))
(defthm msort-preserves-len>=1-case
   (= (len (msort(cons x xs)))
      (1+ (len (msort xs)))))
(defthm msort-preserves-len
   (= (len (msort xs)) (len xs)))
(defthm mrg-conservation-of-values
   (iff (member-equal e (mrg xs ys))
        (or (member-equal e xs) (member-equal e ys))))
;(defthm msort-conservation-of-values ;ACL2 needs help with this thm
;  (iff (member-equal e xs)
;       (member-equal e (msort xs))))
